package be.cylab.java.wowa.training;

import java.util.List;
import java.util.Random;

public class Utils {
    /**
     * @param weights
     * @return
     */
    public static double[] normalizeWeights(final double[] weights) {
        double sum_weight = Utils.sumArrayElements(weights);
        double[] weightsNormalized = new double[weights.length];
        for (int i = 0; i < weights.length; i++) {
            weightsNormalized[i] = weights[i] / sum_weight;
        }
        return weightsNormalized;
    }

    /**
     * @param solutions
     * @return
     */
    public static double findMaxDistance(final List<SolutionDistance> solutions) {
        double max = Double.NEGATIVE_INFINITY;
        for (SolutionDistance solution : solutions) {
            if (solution.getDistance() > max) {
                max = solution.getDistance();
            }
        }
        return max;
    }

    /**
     * @param solutions
     * @return
     */
    public static double findMinDistance(final List<SolutionDistance> solutions) {
        double min = Double.POSITIVE_INFINITY;
        for (SolutionDistance solution : solutions) {
            if (solution.getDistance() < min) {
                min = solution.getDistance();
            }
        }
        return min;
    }

    /**
     * @param solutions
     * @return
     */
    public static double sumTotalDistance(final List<SolutionDistance> solutions) {
        double sum = 0;
        for (SolutionDistance solution : solutions) {
            sum += solution.getDistance();
        }
        return sum;
    }

    /**
     * @param array
     * @return
     */
    private static double sumArrayElements(final double[] array) {
        float sum = 0;
        for (double weight : array) {
            sum += weight;
        }
        return sum;
    }

    /**
     * @param min
     * @param max
     * @return
     */
    public static int randomInteger(final int min, final int max) {
        if (min >= max) {
            throw new IllegalArgumentException("Max must be greater then min");
        }
        Random rnd = new Random();
        return rnd.nextInt((max - min) + 1) + min;
    }


}
